
struct nk_glfw_vertex 
{
    float position[2];
    float uv[2];
    nk_byte col[4];
};

// possibly not best practice but avoids dragging in
// the whole header for just two defines...
#define GLuint unsigned int
#define GLint int

struct nkdevice 
{
    struct nk_buffer cmds;
    struct nk_draw_null_texture null;
    GLuint vbo, vao, ebo;
    GLuint prog;
    GLuint vert_shdr;
    GLuint frag_shdr;
    GLint attrib_pos;
    GLint attrib_uv;
    GLint attrib_col;
    GLint uniform_tex;
    GLint uniform_proj;
    GLuint font_tex;
};

struct media 
{
    GLint skin;
    struct nk_image menu;
    struct nk_image check;
    struct nk_image check_cursor;
    struct nk_image option;
    struct nk_image option_cursor;
    struct nk_image header;
    struct nk_image window;
    struct nk_image scrollbar_inc_button;
    struct nk_image scrollbar_inc_button_hover;
    struct nk_image scrollbar_dec_button;
    struct nk_image scrollbar_dec_button_hover;
    struct nk_image button;
    struct nk_image button_hover;
    struct nk_image button_active;
    struct nk_image tab_minimize;
    struct nk_image tab_maximize;
    struct nk_image slider;
    struct nk_image slider_hover;
    struct nk_image slider_active;
};

void set_gui_colours( struct nk_context *ctx );
void device_draw( struct nkdevice *dev, struct nk_context *ctx, int width, int height,
                 struct nk_vec2 scale, enum nk_anti_aliasing AA );
//void styleGUI( struct nk_context *ctx, Texture2D tex );
void pumpInput( struct nk_context *ctx, Vector2 mp );
void setClipCallbacks ( struct nk_context *ctx );
void initialiseGUI( struct nkdevice *dev, struct nk_context *ctx, const char* fontName );
void shutDownGUI( struct nkdevice *dev, struct nk_context *ctx );

